package com.yyxxgame.columbus

import android.app.Activity
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.os.Message
import android.view.View
import android.widget.*
import cn.yyxx.columbus.base.Columbus
import cn.yyxx.columbus.base.internal.ICallback
import cn.yyxx.columbus.core.entity.LoginType
import cn.yyxx.columbus.core.entity.Session
import cn.yyxx.columbus.core.utils.SessionUtils


/**
 * @author #Suyghur.
 * Created on 2021/06/09
 */
class DemoActivity : Activity(), View.OnClickListener {

    private val events = arrayListOf(
        Item(0, "00 接口环境切换"),
        Item(1, "01 登录"),
        Item(2, "02 切换账号"),
        Item(3, "03 角色创建上报"),
        Item(4, "04 角色登录上报"),
        Item(5, "05 角色升级上报"),
        Item(6, "06 定额充值"),
        Item(7, "07 模拟写入5条账号信息"),
        Item(8, "08 模拟写入游客登录信息"),
        Item(9, "09 模拟写入Facebook登录信息"),
        Item(10, "10 模拟写入Google登录信息")
    )


    private lateinit var layout: LinearLayout
    private lateinit var mTextView: TextView

    private val handler = object : Handler(Looper.getMainLooper()) {
        override fun handleMessage(msg: Message) {
            when (msg.what) {
                10001 -> {
                    with(mTextView) {
                        text = text.toString() + msg.obj.toString()
                    }
                }
            }
        }
    }


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        Columbus.getInstance().initialize(this, false, object : ICallback {
            override fun onResult(code: Int, result: String) {
            }
        })
        initView()
    }

    private fun initView() {
        layout = LinearLayout(this)
        layout.orientation = LinearLayout.VERTICAL
        initButton()
        mTextView = TextView(this)
        with(mTextView) {
            text = ""
            this@DemoActivity.layout.addView(this)
        }
//        val spinner = YSpinner(this)
//        layout.addView(spinner)
        val scrollView = ScrollView(this)
        scrollView.addView(layout)
        setContentView(scrollView)
    }


    private fun initButton() {
        for (event in events) {
            with(Button(this)) {
                text = event.name
                tag = event.id
                id = event.id
                setOnClickListener(this@DemoActivity)
                this@DemoActivity.layout.addView(this)
            }
        }
    }


//    fun hex2bytes(src: String): ByteArray {
//        val len = src.length / 2
//        val ret = ByteArray(len)
//        for (i in 0 until len) {
//            ret[i] = (src.substring(i * 2, i * 2 + 2) as Int).toByte()
//        }
//    }
//    public static byte[] hexString2Bytes(String src)
//    {
//        int l = src . length () / 2;
//        byte[] ret = new byte[l];
//        for (int i = 0; i < l; i++) {
//        ret[i] = Integer.valueOf(src.substring(i * 2, i * 2 + 2), 16).byteValue();
//    }
//        return ret;
//    }


    override fun onClick(v: View?) {
        v?.apply {
            when (tag as Int) {
                0 -> EnvActivity.start(this@DemoActivity)
                1 -> {
                    Columbus.getInstance().login(this@DemoActivity, true, object : ICallback {
                        override fun onResult(code: Int, result: String) {

                        }
                    })
                }
                2 -> {


                }
                3 -> {


                }
                7 -> {
                    val uids = arrayListOf("uid1000", "uid1001", "uid1002", "uid1003", "uid1004")
                    uids.forEach {
                        val session = Session()
                        session.userId = it
                        session.userName = "test$it"
                        session.pwd = "test$it"
                        session.loginType = LoginType.TYPE_ACCOUNT_LOGIN
                        SessionUtils.getInstance().saveSession(this@DemoActivity, session)
                    }
                }
                8 -> {
                    val session = Session()
                    session.userId = "uid1005"
                    session.loginType = LoginType.TYPE_GUEST_LOGIN
                    SessionUtils.getInstance().saveSession(this@DemoActivity, session)
                }
                9 -> {
                    val session = Session()
                    session.userId = "uid1006"
                    session.loginType = LoginType.TYPE_FACEBOOK_LOGIN
                    SessionUtils.getInstance().saveSession(this@DemoActivity, session)
                }
                10 -> {
                    val session = Session()
                    session.userId = "uid1007"
                    session.loginType = LoginType.TYPE_GOOGLE_LOGIN
                    SessionUtils.getInstance().saveSession(this@DemoActivity, session)
                }
            }
        }
    }


}