//
// Created by #Suyghur, on 2021/06/21.
//

#include <toolkit.h>
#include <aes/aes_utils.h>
#include <comm_map.h>
#include <logger.h>
#include <rsa/rsa_utils.h>
#include <url_utils.h>
#include "include/request_kit.h"


std::string RequestKit::EncryptRequest(JNIEnv *env, jobject context, jstring params) {
    //报文的原文
    std::string raw = ToolKit::ToJsonString(HandleRequest(env, params));
    //aes key
    uint8_t *key = AesUtils::GetKey();
    std::string p = AesUtils::Encrypt(raw.c_str(), key);

    //rsa加密aes key
    std::string ts = RsaUtils::EncryptByPublicKey(PUBLIC_KEY, reinterpret_cast<const char *>(key));

    Json::Value root;
    root["p"] = p;
    root["ts"] = ts;
    return ToolKit::ToJsonString(root);
}

Json::Value RequestKit::HandleRequest(JNIEnv *env, jstring params) {
    Json::Value root;
    std::string params_ = ToolKit::JString2String(env, params);
    root = ToolKit::ToJsonObject(params_);
    root["common"] = CommMap::GetInstance()->comm_params;
    return root;
}


